// ===========================================================================
//	CLGCommander.h						
// ===========================================================================

#ifndef _H_CLGCommander
#define _H_CLGCommander

#if defined(__MWERKS__)
#	pragma once
#endif

// PowerPlant headers
#include <LCommander.h>
#include <LListener.h>
#include <LPeriodical.h>


// forward class declarations

class CLG_CharsGrid;
class CLG_CharInfo;
class LTextEdit;
class LStdPopupMenu;

//-------------------------
class CLGCommander : public LCommander, public LPeriodical, public LListener
{
public:
				CLGCommander(LCommander *inSuperCommander);
	virtual		~CLGCommander(void);
	
	OSErr		CreateWindow(void);
	
	
	Boolean		AllowSubRemoval(LCommander *inSub);
	Boolean		ObeyCommand(CommandT inCommand, void *ioParam);
	void		FindCommandStatus(CommandT inCommand,
							Boolean &outEnabled, Boolean &outUsesMark,
							Char16 &outMark, Str255 outName);
	
	void		SpendTime(const EventRecord &inMacEvent);
	
	void		AllowPaging( Boolean inFlag);
	void 		DoScriptActMenu( void);
	
	void		ListenToMessage(
							MessageT		inMessage,
							void			*ioParam);
		
	//----------------------------------
	LWindow				*mWindow;
	LStdPopupMenu		*mMenuDrawAction;
	LStdPopupMenu		*mMenuScriptAction;
	LButton 			*mBtnUp;
	LButton	 			*mBtnDown;

	CLG_CharsGrid		*mCharsGrid;
	CLG_CharInfo		*mCharInfo;
	
	long				mCurScriptNum;
	Rect				mLastCGRect;
	Point				mLastCGChar;
	
		
protected:
	

};

#endif	// _H_CLGCommander
